| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
SoIndexedFaceSet Class Reference
Node Classes

The SoIndexedFaceSet class is used to handle generic indexed facesets.Faces are specified using the coordIndex field. Each face must be terminated by a negative (-1) index. Coordinates, normals, materials and texture coordinates from the current state (or from the vertexProperty node if set), can be indexed to create triangles, quads or polygons. More...

`#include <Inventor/nodes/SoIndexedFaceSet.h>`

Inheritance diagram for SoIndexedFaceSet:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoIndexedFaceSet (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalBundle *bundle)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalCache *cache)

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoIndexedShape
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoVertexShape
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoShape
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | getScreenSize (SoState *const state, const SbBox3f &boundingbox, SbVec2s &rectsize)
static float | getDecimatedComplexity (SoState *state, float complexity)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoIndexedFaceSet ()
virtual void | generatePrimitives (SoAction *action)
Protected Member Functions inherited from SoIndexedShape
| SoIndexedShape (void)
virtual | ~SoIndexedShape ()
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
int | getNumVerts (const int startCoord)
void | setupIndices (const int numParts, const int numFaces, const SbBool needNormals, const SbBool needTexCoords)
const int32_t * | getNormalIndices (void)
const int32_t * | getColorIndices (void)
const int32_t * | getTexCoordIndices (void)
SbBool | getVertexData (SoState *state, const SoCoordinateElement *&coords, const SbVec3f *&normals, const int32_t *&cindices, const int32_t *&nindices, const int32_t *&tindices, const int32_t *&mindices, int &numcindices, const SbBool needNormals, SbBool &normalCacheUsed)
Protected Member Functions inherited from SoVertexShape
| SoVertexShape (void)
virtual | ~SoVertexShape ()
virtual SbBool | shouldGLRender (SoGLRenderAction *action)
void | setNormalCache (SoState *const state, const int num, const SbVec3f *normals)
SoNormalCache * | getNormalCache (void) const
SoNormalCache * | generateAndReadLockNormalCache (SoState *const state)
void | getVertexData (SoState *state, const SoCoordinateElement *&coords, const SbVec3f *&normals, const SbBool neednormals)
void | readLockNormalCache (void)
void | readUnlockNormalCache (void)
Protected Member Functions inherited from SoShape
| SoShape (void)
virtual | ~SoShape ()
float | getComplexityValue (SoAction *action)
void | beginSolidShape (SoGLRenderAction *action)
void | endSolidShape (SoGLRenderAction *action)
void | GLRenderBoundingBox (SoGLRenderAction *action)
SbBool | shouldPrimitiveCount (SoGetPrimitiveCountAction *action)
SbBool | shouldRayPick (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action, const SbMatrix &matrix)
virtual SoDetail * | createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)
virtual SoDetail * | createLineSegmentDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, SoPickedPoint *pp)
virtual SoDetail * | createPointDetail (SoRayPickAction *action, const SoPrimitiveVertex *v, SoPickedPoint *pp)
void | invokeTriangleCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2, const SoPrimitiveVertex *const v3)
void | invokeLineSegmentCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2)
void | invokePointCallbacks (SoAction *const action, const SoPrimitiveVertex *const v)
void | beginShape (SoAction *const action, const TriangleShape shapetype, SoDetail *const detail=NULL)
void | shapeVertex (const SoPrimitiveVertex *const v)
void | endShape (void)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoTextureCoordinateElement *const tce, const float s, const float t, const SbVec3f &normal)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoTextureCoordinateElement *const tce, const float s, const float t, const float r, const SbVec3f &normal)
SbBool | startVertexArray (SoGLRenderAction *action, const SoCoordinateElement *coords, const SbVec3f *pervertexnormals, const SbBool texpervertex, const SbBool colorpervertex)
void | finishVertexArray (SoGLRenderAction *action, const SbBool vbo, const SbBool normpervertex, const SbBool texpervertex, const SbBool colorpervertex)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoIndexedShape
static const SoFieldData ** | getFieldDataPtr (void)
static SbBool | areTexCoordsIndexed (SoAction *action)
Static Protected Member Functions inherited from SoVertexShape
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoShape
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)

## Additional Inherited Members

Public Types inherited from SoShape
enum | TriangleShape { TRIANGLE_STRIP, TRIANGLE_FAN, TRIANGLES, POLYGON, QUADS, QUAD_STRIP, POINTS, LINES, LINE_STRIP }
Public Attributes inherited from SoIndexedShape
SoMFInt32 | coordIndex
SoMFInt32 | materialIndex
SoMFInt32 | normalIndex
SoMFInt32 | textureCoordIndex
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoIndexedFaceSet class is used to handle generic indexed facesets.

Faces are specified using the coordIndex field. Each face must be terminated by a negative (-1) index. Coordinates, normals, materials and texture coordinates from the current state (or from the vertexProperty node if set), can be indexed to create triangles, quads or polygons.

Here's a usage example of just about the simplest possible use of this node, to show a single polygon face:

    #Inventor V2.1 ascii

    Separator {
       Coordinate3 {
          point [ 0 0 0, 1 0 0, 1 1 0 ]
       }
       IndexedFaceSet {
          coordIndex [ 0, 1, 2, -1 ]
       }
    }

Binding PER_VERTEX_INDEXED, PER_VERTEX, PER_FACE_INDEXED, PER_FACE or OVERALL can be set for material, and normals. The default material binding is OVERALL. The default normal binding is PER_VERTEX_INDEXED. When PER_VERTEX_INDEXED binding is used and the corresponding materialIndex, normalIndex, texCoordIndex field is empty, the coordIndex field will be used to index material, normal or texture coordinate. If you do specify indices for material, normals or texture coordinates for PER_VERTEX_INDEXED binding, make sure your index array matches the coordIndex array: there should be a -1 wherever there is a -1 in the coordIndex field. This is done to make this node more easily readable for humans.

A fairly common request when rendering facesets is how to display a set of faces with different colors on the backside versus the frontside. There is not direct support for this in the API, but it can easily be implemented by duplicating all faces in both the SoShapeHints::COUNTERCLOCKWISE and the SoShapeHints::CLOCKWISE order. Here is a simple usage example, showing the technique for a single polygon, using two SoFaceSet nodes for rendering the same polygon from both sides:

    #Inventor V2.1 ascii

    Separator {
       Coordinate3 { point [ 0 0 0, 1 0 0, 1 1 0 ] }

       Separator {
          Material { diffuseColor [ 1 1 0 ] }
          ShapeHints {
             vertexOrdering COUNTERCLOCKWISE
             shapeType SOLID
          }
          FaceSet { numVertices [ 3 ] }
       }

       Separator {
          Material { diffuseColor [ 1 0 0 ] }
          ShapeHints {
             vertexOrdering CLOCKWISE
             shapeType SOLID
          }
          FaceSet { numVertices [ 3 ] }
       }
    }

The same effect can also be done in the following manner, using an SoIndexedFaceSet to explicitly render the polygon coordinates in both directions (clockwise and counterclockwise):

    #Inventor V2.1 ascii

    Separator {
       Coordinate3 { point [ 0 0 0, 1 0 0, 1 1 0 ] }

       Material { diffuseColor [ 1 0 0, 1 1 0 ] }
       MaterialBinding { value PER_FACE_INDEXED }

       ShapeHints {
          vertexOrdering COUNTERCLOCKWISE
          shapeType SOLID
       }

       IndexedFaceSet {
          coordIndex [ 0, 1, 2, -1, 2, 1, 0, -1 ]
          materialIndex [ 0, 1 ]
       }
    }

Another rather rare issue that might be interesting to know about is that to render polygons with concave borders, you should set up an SoShapeHints node with SoShapeHints::faceType set to SoShapeHints::UNKNOWN_FACE_TYPE in the scene graph before the SoIndexedFaceSet (or SoFaceSet) node. This needs to be done to force the rendering code to tessellate the polygons properly to triangles before sending it off to OpenGL. Without it, the polygons will be sent as-is to OpenGL, and the OpenGL implementation's tessellator is often not able to tessellate properly. Here is an example which usually fails without the SoShapeHints node (try commenting it out, and see what happens):

    #Inventor V2.1 ascii

    ShapeHints { faceType UNKNOWN_FACE_TYPE }

    Coordinate3
    {
            point [ 2 0 0,
                    1 0 0,
                    1 1 0,
                    0 1 0,
                    0 2 0,
                    1 2 0,
                    2 2 0,
                    2 1 0 ]
    }

    FaceSet {}

FILE FORMAT/DEFAULTS:

IndexedFaceSet {
vertexProperty NULL
coordIndex 0
materialIndex -1
normalIndex -1
textureCoordIndex -1
}

See Also
  SoFaceSet, SoIndexedTriangleStripSet

## Constructor & Destructor Documentation

SoIndexedFaceSet::SoIndexedFaceSet | ( | void | ) |  |

Constructor.

SoIndexedFaceSet::~SoIndexedFaceSet | ( | ) |  |

protectedvirtual

Destructor.

## Member Function Documentation

SoType SoIndexedFaceSet::getTypeId | ( | void | ) |  | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoIndexedShape.

const SoFieldData * SoIndexedFaceSet::getFieldData | ( | void | ) |  | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoIndexedShape.

void SoIndexedFaceSet::GLRender | ( | SoGLRenderAction * | action) |  |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoShape.

void SoIndexedFaceSet::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action) |  |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables.

Reimplemented from SoShape.

SbBool SoIndexedFaceSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalBundle * | bundle
| ) |  |

virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalBundle class. `TRUE` should be returned if normals were generated, `FALSE` otherwise.

Default method returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

SbBool SoIndexedFaceSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalCache * | cache
| ) |  |

virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return `TRUE` if normals were generated, `FALSE` otherwise.

Default method just returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

void SoIndexedFaceSet::generatePrimitives | ( | SoAction * | action) |  |

protectedvirtual

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

The documentation for this class was generated from the following files:

- SoIndexedFaceSet.h
- SoIndexedFaceSet.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.